Create one independently managed protection for an external provider key
curl --request POST \
--url https://api.airctrl.dev/v1/oauth/protections \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"externalResourceId": "<string>",
"providerId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"providerKey": "<string>",
"gatewayName": "<string>",
"models": [
"<string>"
],
"credentialLabel": "<string>",
"settings": {
"spendLimit": 1,
"rateLimitPerMin": 2,
"loggingEnabled": true,
"logBodies": true
}
}
'import requests
url = "https://api.airctrl.dev/v1/oauth/protections"
payload = {
"externalResourceId": "<string>",
"providerId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"providerKey": "<string>",
"gatewayName": "<string>",
"models": ["<string>"],
"credentialLabel": "<string>",
"settings": {
"spendLimit": 1,
"rateLimitPerMin": 2,
"loggingEnabled": True,
"logBodies": True
}
}
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
externalResourceId: '<string>',
providerId: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
providerKey: '<string>',
gatewayName: '<string>',
models: ['<string>'],
credentialLabel: '<string>',
settings: {spendLimit: 1, rateLimitPerMin: 2, loggingEnabled: true, logBodies: true}
})
};
fetch('https://api.airctrl.dev/v1/oauth/protections', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.airctrl.dev/v1/oauth/protections",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'externalResourceId' => '<string>',
'providerId' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'providerKey' => '<string>',
'gatewayName' => '<string>',
'models' => [
'<string>'
],
'credentialLabel' => '<string>',
'settings' => [
'spendLimit' => 1,
'rateLimitPerMin' => 2,
'loggingEnabled' => true,
'logBodies' => true
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.airctrl.dev/v1/oauth/protections"
payload := strings.NewReader("{\n \"externalResourceId\": \"<string>\",\n \"providerId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"providerKey\": \"<string>\",\n \"gatewayName\": \"<string>\",\n \"models\": [\n \"<string>\"\n ],\n \"credentialLabel\": \"<string>\",\n \"settings\": {\n \"spendLimit\": 1,\n \"rateLimitPerMin\": 2,\n \"loggingEnabled\": true,\n \"logBodies\": true\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.airctrl.dev/v1/oauth/protections")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"externalResourceId\": \"<string>\",\n \"providerId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"providerKey\": \"<string>\",\n \"gatewayName\": \"<string>\",\n \"models\": [\n \"<string>\"\n ],\n \"credentialLabel\": \"<string>\",\n \"settings\": {\n \"spendLimit\": 1,\n \"rateLimitPerMin\": 2,\n \"loggingEnabled\": true,\n \"logBodies\": true\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.airctrl.dev/v1/oauth/protections")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"externalResourceId\": \"<string>\",\n \"providerId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"providerKey\": \"<string>\",\n \"gatewayName\": \"<string>\",\n \"models\": [\n \"<string>\"\n ],\n \"credentialLabel\": \"<string>\",\n \"settings\": {\n \"spendLimit\": 1,\n \"rateLimitPerMin\": 2,\n \"loggingEnabled\": true,\n \"logBodies\": true\n }\n}"
response = http.request(request)
puts response.read_body{
"ok": true,
"data": {
"protectionId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"externalResourceId": "<string>",
"project": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>"
},
"serviceAccount": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>",
"active": true
},
"providerCredential": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"providerId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"providerSlug": "<string>",
"label": "<string>"
},
"gateway": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"slug": "<string>",
"name": "<string>",
"models": [
"<string>"
],
"settings": {
"spendLimit": 1,
"spendWindow": "daily",
"rateLimitPerMin": 2,
"loggingEnabled": true,
"logBodies": true,
"guardrailMode": "off"
}
},
"gatewayToken": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"prefix": "<string>"
},
"state": "active",
"accessRevokedAt": "2023-11-07T05:31:56Z",
"connectionSuspendedAt": "2023-11-07T05:31:56Z",
"createdAt": "2023-11-07T05:31:56Z",
"replayed": true
}
}{
"error": "<string>",
"code": "<string>",
"message": "<string>",
"error_description": "<string>",
"requestId": "<string>"
}{
"error": "<string>",
"code": "<string>",
"message": "<string>",
"error_description": "<string>",
"requestId": "<string>"
}{
"error": "<string>",
"code": "<string>",
"message": "<string>",
"error_description": "<string>",
"requestId": "<string>"
}{
"error": "<string>",
"code": "<string>",
"message": "<string>",
"error_description": "<string>",
"requestId": "<string>"
}{
"error": "<string>",
"code": "<string>",
"message": "<string>",
"error_description": "<string>",
"requestId": "<string>"
}OAuth
Create one independently managed protection for an external provider key
POST
/
oauth
/
protections
Create one independently managed protection for an external provider key
curl --request POST \
--url https://api.airctrl.dev/v1/oauth/protections \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"externalResourceId": "<string>",
"providerId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"providerKey": "<string>",
"gatewayName": "<string>",
"models": [
"<string>"
],
"credentialLabel": "<string>",
"settings": {
"spendLimit": 1,
"rateLimitPerMin": 2,
"loggingEnabled": true,
"logBodies": true
}
}
'import requests
url = "https://api.airctrl.dev/v1/oauth/protections"
payload = {
"externalResourceId": "<string>",
"providerId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"providerKey": "<string>",
"gatewayName": "<string>",
"models": ["<string>"],
"credentialLabel": "<string>",
"settings": {
"spendLimit": 1,
"rateLimitPerMin": 2,
"loggingEnabled": True,
"logBodies": True
}
}
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
externalResourceId: '<string>',
providerId: '3c90c3cc-0d44-4b50-8888-8dd25736052a',
providerKey: '<string>',
gatewayName: '<string>',
models: ['<string>'],
credentialLabel: '<string>',
settings: {spendLimit: 1, rateLimitPerMin: 2, loggingEnabled: true, logBodies: true}
})
};
fetch('https://api.airctrl.dev/v1/oauth/protections', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.airctrl.dev/v1/oauth/protections",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'externalResourceId' => '<string>',
'providerId' => '3c90c3cc-0d44-4b50-8888-8dd25736052a',
'providerKey' => '<string>',
'gatewayName' => '<string>',
'models' => [
'<string>'
],
'credentialLabel' => '<string>',
'settings' => [
'spendLimit' => 1,
'rateLimitPerMin' => 2,
'loggingEnabled' => true,
'logBodies' => true
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.airctrl.dev/v1/oauth/protections"
payload := strings.NewReader("{\n \"externalResourceId\": \"<string>\",\n \"providerId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"providerKey\": \"<string>\",\n \"gatewayName\": \"<string>\",\n \"models\": [\n \"<string>\"\n ],\n \"credentialLabel\": \"<string>\",\n \"settings\": {\n \"spendLimit\": 1,\n \"rateLimitPerMin\": 2,\n \"loggingEnabled\": true,\n \"logBodies\": true\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.airctrl.dev/v1/oauth/protections")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"externalResourceId\": \"<string>\",\n \"providerId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"providerKey\": \"<string>\",\n \"gatewayName\": \"<string>\",\n \"models\": [\n \"<string>\"\n ],\n \"credentialLabel\": \"<string>\",\n \"settings\": {\n \"spendLimit\": 1,\n \"rateLimitPerMin\": 2,\n \"loggingEnabled\": true,\n \"logBodies\": true\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.airctrl.dev/v1/oauth/protections")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"externalResourceId\": \"<string>\",\n \"providerId\": \"3c90c3cc-0d44-4b50-8888-8dd25736052a\",\n \"providerKey\": \"<string>\",\n \"gatewayName\": \"<string>\",\n \"models\": [\n \"<string>\"\n ],\n \"credentialLabel\": \"<string>\",\n \"settings\": {\n \"spendLimit\": 1,\n \"rateLimitPerMin\": 2,\n \"loggingEnabled\": true,\n \"logBodies\": true\n }\n}"
response = http.request(request)
puts response.read_body{
"ok": true,
"data": {
"protectionId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"externalResourceId": "<string>",
"project": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>"
},
"serviceAccount": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>",
"active": true
},
"providerCredential": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"providerId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"providerSlug": "<string>",
"label": "<string>"
},
"gateway": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"slug": "<string>",
"name": "<string>",
"models": [
"<string>"
],
"settings": {
"spendLimit": 1,
"spendWindow": "daily",
"rateLimitPerMin": 2,
"loggingEnabled": true,
"logBodies": true,
"guardrailMode": "off"
}
},
"gatewayToken": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"prefix": "<string>"
},
"state": "active",
"accessRevokedAt": "2023-11-07T05:31:56Z",
"connectionSuspendedAt": "2023-11-07T05:31:56Z",
"createdAt": "2023-11-07T05:31:56Z",
"replayed": true
}
}{
"error": "<string>",
"code": "<string>",
"message": "<string>",
"error_description": "<string>",
"requestId": "<string>"
}{
"error": "<string>",
"code": "<string>",
"message": "<string>",
"error_description": "<string>",
"requestId": "<string>"
}{
"error": "<string>",
"code": "<string>",
"message": "<string>",
"error_description": "<string>",
"requestId": "<string>"
}{
"error": "<string>",
"code": "<string>",
"message": "<string>",
"error_description": "<string>",
"requestId": "<string>"
}{
"error": "<string>",
"code": "<string>",
"message": "<string>",
"error_description": "<string>",
"requestId": "<string>"
}Authorizations
The access token received from the authorization server in the OAuth 2.0 flow.
Scopes
protections:provision
Atomically create the disclosed AIRCTRL resources for a protected external key.
Headers
Caller-generated operation key. Same key and request replay the same result; a different request returns 409.
Required string length:
16 - 200Body
application/json
Required string length:
1 - 255Required string length:
1 - 2000Required string length:
3 - 100Minimum array length:
1Required string length:
1 - 100Show child attributes
Show child attributes
Show child attributes
Show child attributes